#cs

This script helps to add abbreviations quickly.  It works thusly:  The user (or a script) adds a bunch of identical dummy segmentation rules to the segmentation.conf file.  The dummy rules contain a certain keywords (currently ABFMuMuL) in the "before" field.  When the user adds an abbreviation, the script searches for the first available instance of the keyword and replaces it with the abbreviation.  OmegaT will recognise it when the user reloads.  The segmentation.conf file can be edited while OmegaT is running.

#ce

#cs
1. Input exception
2. Open seg file
3. Read file
4. Find mumu and replace first instance with exception
5. Write seg file again
6. Close file
#ce

$exception = InputBox ("Enter exception", "Copy and paste the exception text here, as-is.  If uncertain, read the readme file for examples and clues and stuff.")

$segfileopen = FileOpen ("segmentation.conf", 0)
$segfileread = FileRead ("segmentation.conf")

; replacements to be made:
; 1. = \.
; 2[ = \[
; 3] = \]
; 4( = \(
; 5) = \)
; 6< = &lt;
; 7> = &gt;
; 8{ = \{
; 9} = \9
; etc

$rep1 = StringReplace ($exception, ".", "\.")
$rep2 = StringReplace ($rep1, "[", "\[")
$rep3 = StringReplace ($rep2, "]", "\]")
$rep4 = StringReplace ($rep3, "(", "\(")
$rep5 = StringReplace ($rep4, ")", "\)")
$rep6 = StringReplace ($rep5, "<", "&lt;")
$rep7 = StringReplace ($rep6, ">", "&gt;")
$rep8 = StringReplace ($rep7, "{", "\{")
$rep9 = StringReplace ($rep8, "}", "\}")
$rep10 = StringReplace ($rep9, "?", "\?")
$rep11 = StringReplace ($rep10, "+", "\+")

$putstuff = StringReplace ($segfileread, "ABFMuMuL", $rep11, 1)

FileClose ($segfileopen)
$segfileopenagain = FileOpen ("segmentation.conf", 2)
FileWrite ($segfileopenagain, $putstuff)
FileClose ($segfileopenagain)

WinActivate ("OmegaT", "")
WinWaitActive ("OmegaT", "")

Send ("!o")
Sleep ("100")
Send ("s")
Sleep ("100")
Send ("{TAB}")
Sleep ("100")
Send ("{TAB}")
Sleep ("100")
Send ("{ESC}")

WinActivate ("OmegaT", "")
WinWaitActive ("OmegaT", "")

Send ("{F5}")

WinActivate ("Project Files", "")
WinWaitActive ("Project Files", "")

Send ("!c")

